<?php

	require("./pre.inc.php");
	include_once(DOL_DOCUMENT_ROOT.'/compta/compta.class.php');
		

	if (!$user->rights->compta->operation->lire)
	    accessforbidden();

	$langs->load("bills");


	$vline=isset($_GET["vline"])?$_GET["vline"]:$_POST["vline"];

	$action_encours=isset($_GET["action_encours"])?$_GET["action_encours"]:$_POST["action_encours"];
	$action_demandee=isset($_GET["action_demandee"])?$_GET["action_demandee"]:$_POST["action_demandee"];
	if ($action_demandee == 'nouvelle_piece' || $action_demandee == 'del_ligne') $action_encours = 'saisir_piece';

	$ligne_del=isset($_GET["ligne_del"])?$_GET["ligne_del"]:$_POST["ligne_del"];
	$page=isset($_GET["page"])?$_GET["page"]:$_POST["page"];
	$confirm_piece=$_POST["confirm_piece"];

	$nb_erreurs = 0;

	if (!$_POST["nb_lignes"] || $action_demandee == 'annule_piece') {
		$nb_lignes = 0;
	}
	else {
		$nb_lignes = $_POST["nb_lignes"];
	}
	// print "<script language='javascript'>alert('".$nb_lignes."');</script>";	
	// print "<script language='javascript'>alert('".$action_encours."');</script>";	
	if ($vline)
    {
      $viewline = $vline;
    }
	else
    {
      $viewline = 22;
    }
	//validation d'une pice
	if ($_POST['action_demandee'] == 'confirm_valid' && $confirm_piece == 'yes' && $user->rights->facture->valider)
	{
		$nb_erreurs=sizeOf($erreurs=_controle_piece($db));
		if ($nb_erreurs == 0) _valid_piece($db);
	}

	// Affichage header dolibarr
	llxHeader();
	$html=new Form($db);

	//controle de la piece
	if ($action_demandee == 'controle_piece') {
		$nb_erreurs=sizeOf($erreurs=_controle_piece($db));
		if ($nb_erreurs == 0) {
			$html->form_confirm("javascript:document.getElementById('confirm_piece').value=document.forms[3].elements['confirm'].value;document.getElementById('action_demandee').value='confirm_valid';document.form_saisie.submit();",'Validation d\'une opration comptable','Etes-vous sr de vouloir valider cette opration comptable ?','confirm_valid');
			print '<br />';
		}
	}

    
 /*
     * Affiche tableau des oprations comptables
     *
     */

    print '<table class="notopnoleftnoright" width="100%">';
    // Formulaire de saisie d'une opration 
    if ($user->rights->banque->modifier && $action_encours == 'saisir_piece' && $action_demandee != 'annule_piece') 
    {
		if (!$_POST["datep"]) {
			$datep = date("d/m/y");
		}
		else {
			$datep = $_POST["datep"];
		}

		print '<form name="form_saisie" method="post" action="ecritures.php">';
        print '<input id="action_demandee" type="hidden" name="action_demandee" value="">';
        print '<input id="action_encours" type="hidden" name="action_encours" value="saisir_piece">';
        print '<input id="confirm_piece" type="hidden" name="confirm_piece" value="no">';
        print '<input type="hidden" name="vline" value="' . $vline . '">';
        print '<input type="hidden" id="ligne_del" name="ligne_del" value="0">';
        print '<input type="hidden" id="page" name="page" value="' . $page . '">';
        
        print '<tr>';
        print '<td align="left" colspan="9">';
		print_fiche_titre($langs->trans("Saisie d'une opration comptable"));
        print '</tr>';

		// Erreurs de la saisie
		if ($nb_erreurs > 0) 
		{
			print '<tr><td colspan="9">';
			$err = 0;
			while ($err < $nb_erreurs) {
				print "<font color='red'>".$erreurs[$err]."</font><br>";
				$err++;
			}
			print '</td></tr>';
		}        
		print '<tr>';
        print '<td align="left" colspan="9">';
		print '<table class="notopnoleftnoright" width="100%">';
    	print '<tr class="liste_titre">';
        print '<td>'.$langs->trans("Date").'</td><td colspan="2">'.$langs->trans("Journal").'</td><td>'.$langs->trans("Type de pice").'</td><td>'.$langs->trans("Libell").'</td>';
        print '</tr>';

        print '<tr '.$bc[true].'>';
        print '<td>';
        print '<input name="datep" class="flat" type="text" size="7" maxlength="10" value="'.$datep.'"></td>';
        print '<td colspan="2"><select class="flat" name="journal">'._charge_journaux($db).'</select></td>';
		print '<td><select class="flat" name="type_piece">'._charge_types_piece($db).'</select></td>';
		print '<td>';
        print '<input name="libelle" class="flat" type="text" size="30" value="'.$_POST["libelle"].'"></td>';
        print '</tr>';
        print '<tr class="liste_titre">';
        print '<td>'.$langs->trans("Montant HT").'</td><td>'.$langs->trans("Montant TVA").'</td><td>'.$langs->trans("Montant TTC").'</td>';
		print '<td colspan="2">'.$langs->trans("Tiers").'</td>';
        print '</tr>';
		print '<tr '.$bc[true].'>';
        print '<td><input name="montant_ht" class="flat" type="text" size="6" value="'.$_POST["montant_ht"].'"></td>';
        print '<td><input name="montant_tva" class="flat" type="text" size="6" value="'.$_POST["montant_tva"].'"></td>';
        print '<td><input name="montant" class="flat" type="text" size="6" value="'.$_POST["montant"].'"></td>';
        print '<td colspan="2"><select class="flat" name="tiers">'._charge_tiers($db).'</select></td>';
		print '</tr>';
        print '</table>';
		print '</td></tr>';
        print '<tr><td colspan="9">';
		print '<table class="notopnoleftnoright" width="100%">';
		
		// Saisie des lignes
		print '<tr '.$bc[false].'>';
		print '<td>'.$langs->trans("Libell ligne").'</td><td>'.$langs->trans("Compte").'</td><td>'.$langs->trans("Nature").'</td><td>'.$langs->trans("Sens").'</td><td colspan="2">'.$langs->trans("Montant").'</td>';
        print '</tr>';
		
		$i = 0;
		$num_ligne = 0;
		$sens_prec = '';
		while ($i < $nb_lignes) { 
			$i++;
			if ($ligne_del != $i) {
				$num_ligne++;
				$sens_prec = _affiche_ligne($db, $i, $sens_prec, $num_ligne, $_POST["type_piece"]);
			}
		}
		$nb_lignes = $num_ligne;
		if ($nb_lignes == 0 || $action_demandee == 'nouvelle_ligne') {
			$num_ligne++;
			$sens_prec = _affiche_ligne($db, 0, $sens_prec, $num_ligne, $_POST["type_piece"]);
			$nb_lignes++;
		}
		if ($nb_lignes == 1) {
			$num_ligne++;
			$sens_prec = _affiche_ligne($db, 1, $sens_prec, $num_ligne, $_POST["type_piece"]);
			$nb_lignes++;
		}
		if ($action_demandee == 'nouvelle_ligne') {
			print '<script language="javascript">document.forms["form_saisie"].elements["libelle_ligne_'.$num_ligne.'"].focus();</script>';
		}
		print '<tr><td align="right" colspan="7"><input type="submit" name="add_line" class="button" value="'.$langs->trans("Ajouter une ligne").'" onclick="document.getElementById(\'action_demandee\').value=\'nouvelle_ligne\';">';
		print '</td></tr>';
		print '</table></td></tr>';
        if ($action_demandee != 'controle_piece' || $nb_erreurs != 0) 
		{
			print '<tr '.$bc[false].'>';
			print '<td colspan="9" align="center">';
        	print '<input type="button" name="save" class="button" value="'.$langs->trans("Valider la pice").'" onclick="document.getElementById(\'action_demandee\').value=\'controle_piece\';document.form_saisie.submit();">&nbsp;&nbsp;&nbsp;';
			print '<input type="button" name="cancel" class="button" value="'.$langs->trans("Cancel").'" onclick="document.getElementById(\'action_demandee\').value=\'annule_piece\';document.form_saisie.submit();">';
			print '</td></tr>';
        }
		print '<input type="hidden" name="nb_lignes" value="'.$nb_lignes.'">';
		print "</form>";

        print "<tr class=\"noborder\"><td colspan=\"9\">&nbsp;</td></tr>\n";
    }

    $sql = "SELECT p.rowid, p.date_piece as datep, p.montant, p.libelle, p.journal, p.num_piece, p.tiers, p.code_origine, p.reference, p.exportee, p.code_lettrage";
    $sql .=", s.nom as libelle_tiers";
	$sql .= " FROM ".MAIN_DB_PREFIX."compta_pieces as p";
	$sql .=" LEFT JOIN ".MAIN_DB_PREFIX."societe as s ON p.tiers = s.idp";
	//filtre de recherche
	_filtre_recherche($db);
	
	print "<tr class=\"noborder\"><td colspan=\"9\">";
	print_fiche_titre("Liste des oprations comptables : ",_entete_pagination($db));
	print "</td></tr>\n";
	
        // Ligne de titre tableau des acritures
    print '<tr class="liste_titre">';
    print '<td>'.$langs->trans("Date").'</td><td>'.$langs->trans("Journal").'</td><td>'.$langs->trans("Num").'</td><td>'.$langs->trans("Libell").'</td><td>'.$langs->trans("Tiers").'</td><td>'.$langs->trans("Origine").'</td><td>'.$langs->trans("Rfrence").'</td>';
    print '<td colspan="2">'.$langs->trans("Montant").'</td>';
    print '</tr>';

	print '<form name="form_affich" method="post">';
	print '<input id="action_demandee" type="hidden" name="action_demandee" value="search">';
    print '<input type="hidden" id="page" name="page" value="' . $page . '">';
	print '<input type="hidden" name="vline" value="' . $vline . '">';
    print '<tr '.$bc[true].'>';
	print '<td>Chercher:</td>';
	print '<td><input type="text" class="flat" name="req_journal" value="'.$_POST["req_journal"].'" size="1"></td>';
	print '<td><input type="text" class="flat" name="req_piece" value="'.$_POST["req_piece"].'" size="4"></td>';
	print '<td><input type="text" class="flat" name="req_libelle" value="'.$_POST["req_libelle"].'" size="30"></td>';
	print '<td><input type="text" class="flat" name="req_tiers" value="'.$_POST["req_tiers"].'" size="20"></td>';
	print '<td><input type="text" class="flat" name="req_origine" value="'.$_POST["req_origine"].'" size="6"></td>';
	print '<td><input type="text" class="flat" name="req_reference" value="'.$_POST["req_reference"].'" size="6"></td>';
	print '<td align="right"><input type="text" class="flat" name="req_montant" value="'.$_POST["req_montant"].'" size="5"></td>';
	print '<td align="center" width="40"><input type="image" class="liste_titre" src="'.DOL_URL_ROOT.'/theme/'.$conf->theme.'/img/search.png" alt="'.$langs->trans("Search").'"></td>';
	print "</tr>\n";
		
	// chargement des pieces  afficher
    $sql.= $sql_rech;
    $sql.= " ORDER BY p.datep ASC, p.journal ASC, p.num_piece ASC";
    $sql.= $db->plimit($limitsql, 0);
	
	//echo '<br>'.$sql.'<br>';
    
    $result = $db->query($sql);
    if ($result)
    {
        $total = _print_piece($db, $result, $sql);
        $db->free($result);
    }
 
    
    print "</form>\n";
	print "</table>";
	
 /*
     *  Boutons actions
     */
    if ($action_encours != 'saisir_piece' || $action_demandee == 'annule_piece')
    {
        print '<div class="tabsAction">';
        
        if ($user->rights->banque->modifier)
        {
            print '<a class="tabAction" href="#"  onclick="document.getElementById(\'action_demandee\').value=\'nouvelle_piece\';document.form_affich.submit();">'.$langs->trans("Saisir une opration").'</a>';
        }
    
        print '</div>';
    }

    print '<br>';
   
$db->close();

llxFooter('$Date: 2005/10/15 16:01:56 $ - $Revision: 1.63 $');


/**
 *      \brief      Affiche ligne ecriture
 *      \param      db          Handler d'accs base
 *      \param      result      Resultset du select
 *      \param      sql         Requete sql
 *      \param      acct        Compte
 *      \return     Renvoi total solde
 */
function _print_piece($db,$result,$sql)
{
    global $langs, $bc, $nb_pieces, $viewline, $user, $page;
    
    $var=true;
    $total=0;
    
    $num = $db->num_rows($result);
    $i = 0; $total = 0; $sep = 0;
    
 //print "<script language='javascript'>alert('".$nb_pieces."');</script>";		
 //print "<script language='javascript'>alert('".$viewline."');</script>";		
    while ($i < $num)
    {
        $objp = $db->fetch_object($result);
        $time = time();
        if ($i >= ($nb_pieces - $viewline))
        {
            $var=!$var;
    
            print "<tr $bc[$var]>";
            print "<td nowrap>".dolibarr_print_date($objp->datep,"%d/%m/%y")."</td>\n";
            print "<td nowrap>&nbsp;".$objp->journal."</td>\n";
            print '<td nowrap>&nbsp;'.$objp->num_piece."</td>\n";
            print "<td nowrap>".$objp->libelle."</td>\n";
			print "<td nowrap>&nbsp;".$objp->libelle_tiers."</td>\n";
            print "<td nowrap>&nbsp;".$objp->code_origine."</td>\n";
            print "<td nowrap>&nbsp;".$objp->reference."</td>\n";
            
            print "<td align=\"right\" nowrap>&nbsp;".price($objp->montant)."</td>\n";
                
            if ($action_demandee =='search')
            {
                print '<td align="right">-</td>';
            }
    
            print "<td align=\"center\"><a href=\"#\" onclick=\"return affichage_lignes(".$objp->rowid.");\">Lignes</a></td>\n";
			print '</tr>';
    
            print '<tr><td colspan="9">';
			_charge_lignes($db, $objp->rowid);
			print "</td></tr>";
		}
    
        $i++;
    }

    return $total;
}

function _print_lignes($db,$result)
{
    global $langs, $bc, $nb_pieces, $viewline, $user, $page;
    
    $var=true;
    $total=0;
    
    $num = $db->num_rows($result);
    $i = 0; $total = 0; $sep = 0;
    
    while ($i < $num)
    {
        $objp = $db->fetch_object($result);
        $time = time();
        //if ($i >= ($nb_pieces - $viewline))
        //{
            $var=!$var;
    
            print "<tr $bc[yes]>";
            print "<td>".$objp->num_ligne."</td>";
            print '<td width=400>'.$objp->libelle."</td>";
            print "<td>".$objp->numero."</td>";
			print "<td>".$objp->sens."</td>";
            print "<td align=\"right\" nowrap>&nbsp;".price($objp->montant)."</td>";
            print "</tr>";
        //}
    
        $i++;
    }

    return $total;
}
// Chrargement lignes de la pice
function _charge_lignes($db, $id_piece) {
	global $langs;
	
	print '<div id="Lignes_'.$id_piece.'" style="display:none;">';
	print '<table class="notopnoleftnoright" width="100%">';
	print '<tr '.$bc[false].'>';
	print '<td>'.$langs->trans("Ligne").'</td><td width=400>'.$langs->trans("Libell ligne").'</td><td>'.$langs->trans("Compte").'</td><td>'.$langs->trans("Sens").'</td><td align="right">'.$langs->trans("Montant").'</td>';
    print '</tr>';

	$sql = "SELECT l.num_ligne, l.libelle, c.numero, l.sens, l.montant FROM ".MAIN_DB_PREFIX."compta_lignes as l  LEFT JOIN ".MAIN_DB_PREFIX."compta_compte_generaux as c ON l.compte=c.rowid  WHERE l.id_piece = ".$id_piece." ORDER BY l.journal, l.num_piece, l.num_ligne";
	$result = $db->query($sql);
    if ($result)
    {
        $total = _print_lignes($db, $result);
        $db->free($result);
    }
	print "</table>";
	print "</div>";	
}

// Chargement des journaux dans $journaux
function _charge_journaux($db)
 {
	$sql = "SELECT code_journal, libelle FROM ".MAIN_DB_PREFIX."compta_journaux ORDER BY code_journal;";
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $journaux = "<option value=\"0\"";
		if (!$_POST["journal"]) {
			$journaux .= " selected=\"true\"";
			$journal_sel = "";
		}
		else {
			$journal_sel = $_POST["journal"];
		}
		$journaux .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
            $journaux .= "<option value=\"$obj->code_journal\"";
			if ($obj->code_journal == $journal_sel) $journaux .= " selected=\"true\"";
			$journaux .= ">$obj->code_journal - $obj->libelle</option>\n";
            $i++;
        }
        $db->free($result);
		return $journaux;
	}
}
// Chargement des tiers dans $liste_tiers
function _charge_tiers($db)
{
	$sql = "SELECT idp, nom FROM ".MAIN_DB_PREFIX."societe ORDER BY nom";
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $liste_tiers = "<option value=\"0\"";
		if (!$_POST["tiers"]) {
			$liste_tiers .= " selected=\"true\"";
			$tiers_sel = "";
		}
		else {
			$tiers_sel = $_POST["tiers"];
		}
		$liste_tiers .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
            $liste_tiers .= "<option value=\"$obj->idp\"";
			if ($obj->idp == $tiers_sel) $liste_tiers .= " selected=\"true\"";
			$liste_tiers .= ">$obj->nom</option>\n";
            $i++;
        }
        $db->free($result);
		return $liste_tiers;
	}
}
// Chargement des comptes dans $comptes_generaux
function _charge_comptes($db, $ligne)
 {
	$sql = "SELECT rowid, numero, intitule FROM ".MAIN_DB_PREFIX."compta_compte_generaux ORDER BY numero;";
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $comptes_generaux = "<option value=\"0\"";
		if (!$_POST["compte_ligne_".$ligne]) {
			$comptes_generaux .= " selected=\"true\"";
			$compte_sel = "";
		}
		else {
			$compte_sel = $_POST["compte_ligne_".$ligne];
		}
		$comptes_generaux .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
            $comptes_generaux .= "<option value=\"$obj->rowid\"";
			if ($obj->rowid == $compte_sel) $comptes_generaux .= " selected=\"true\"";
			$comptes_generaux .= ">$obj->numero - $obj->intitule</option>\n";
            $i++;
        }
        $db->free($result);
		return $comptes_generaux;
	}
}
// Chargement des types de pice
function _charge_types_piece($db)
 {
	$sql = "SELECT rowid, libelle FROM ".MAIN_DB_PREFIX."compta_type_piece ORDER BY journal ASC, libelle ASC";
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $liste_types = "<option value=\"\"";
		if (!$_POST["type_piece"]) {
			$liste_types .= " selected=\"true\"";
			$type_sel = "";
		}
		else {
			$type_sel = $_POST["type_piece"];
		}
		$liste_types .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
			$liste_types .= "<option value=\"$obj->rowid\"";
			if ($obj->rowid == $type_sel) $liste_types .= " selected=\"true\"";
			$liste_types .= ">$obj->libelle</option>\n";
            $i++;
        }
		$db->free($result);
		return $liste_types;
	}
}
// Chargement des natures
function _charge_natures($db, $type_piece, $ligne)
 {
	$sql = "SELECT rowid, libelle FROM ".MAIN_DB_PREFIX."compta_natures";
	if ($type_piece != '') $sql .= " WHERE type_nature = '" .$type_piece."'";
	$sql .= " ORDER BY type_nature, libelle ASC";
	$result = $db->query($sql);
	if ($result)
    {
        $num = $db->num_rows($result);
        $i = 1;
        $liste_natures = "<option value=\"0\"";
		if (!$_POST["nature_ligne_".$ligne]) {
			$liste_natures .= " selected=\"true\"";
			$nature_sel = "";
		}
		else {
			$nature_sel = $_POST["nature_ligne_".$ligne];
		}
		$liste_natures .= ">&nbsp;</option>";
        while ($i <= $num)
        {
            $obj = $db->fetch_object($result);
            $liste_natures .= "<option value=\"$obj->rowid\"";
			if ($obj->rowid == $nature_sel) $liste_natures .= " selected=\"true\"";
			$liste_natures .= ">$obj->libelle</option>\n";
            $i++;
        }
        $db->free($result);
		return $liste_natures;
	}
}

// affichage d'une ligne
function _affiche_ligne($db, $i, $sens_prec, $num_ligne, $type_piece) {
	print '<tr '.$bc[true].'>';
	print '<td><input name="libelle_ligne_'.$num_ligne.'" class="flat" type="text" size="20" value="'.$_POST["libelle_ligne_".$i].'"></td>';
	print '<td><select class="flat" name="compte_ligne_'.$num_ligne.'">'._charge_comptes($db, $i).'</select></td>';
	print '<td><select class="flat" name="nature_ligne_'.$num_ligne.'">'._charge_natures($db, $type_piece, $i).'</select></td>';
	print '<td><select name="sens_ligne_'.$num_ligne.'" class="flat">';
	print '<option value="D"';
	if ($_POST["sens_ligne_".$i] == 'D') {
		$sens = 'D';
		print " selected";
	}
	elseif ($sens_prec == 'C' && $_POST["sens_ligne_".$i] != 'C') {
		$sens = 'D';
		print " selected";
	}
	print '>Dbit</option>';
	print '<option value="C"';
	if ($_POST["sens_ligne_".$i] == 'C') {
		$sens = 'C';
		print " selected";
	}
	elseif ($sens_prec == 'D' && $_POST["sens_ligne_".$i] != 'D') {
		$sens = 'C';
		print " selected";
	}
	print '>Crdit</option>';
	print '</select>';
	print '</td>';
	print '<td><input name="montant_ligne_'.$num_ligne.'" class="flat" type="text" size="6" value="'.$_POST["montant_ligne_".$i].'"></td>';
	print '<td align="center">';
	print '<a href="#" onclick="document.getElementById(\'action_demandee\').value=\'del_ligne\';document.getElementById(\'ligne_del\').value='.$num_ligne.';document.form_saisie.submit();">';
	print img_delete();
	print '</a></td>';
	print '</tr>';
	return $sens != ''?$sens:'D';
}

// validation d'une piece
function _valid_piece($db)
{
	global $user;
	
	$date_piece = strftime( "%Y-%m-%d", mktime(0, 0, 0, substr($_POST["datep"],3,2), substr($_POST["datep"],0,2), substr($_POST["datep"],6)));
	$journal=$_POST["journal"];
    $libelle=$_POST["libelle"];
    $montant=str_replace(',', '.', $_POST["montant"]);
    $tiers=$_POST["tiers"];
	$reference=$_POST["reference"];
	$code_origine=$user->login;
	$type_piece=$_POST['type_piece'];
	$montant_ht=str_replace(',', '.', $_POST["montant_ht"]);
    $montant_tva=str_replace(',', '.', $_POST["montant_tva"]);
    
    $db->begin();
	$piece=new Piece($db);
	$id_piece = $piece->nouvelle_piece($journal, $date_piece, $montant, $libelle, $tiers, $code_origine, $reference, $type_piece, $montant_ht, $montant_tva, $mrg);
	
    if ($id_piece)
    {
        $i = 1;
		$err = 0;
		while ($i <= $_POST["nb_lignes"]) {
			$libelle_ligne = $_POST["libelle_ligne_".$i];
			if ($libelle_ligne == '') $libelle_ligne = $libelle;
			$ligne = new Ligne($db);
			$id_ligne = $ligne->nouvelle_ligne($id_piece, $i, $journal, $piece->getNumPiece(), $_POST["nature_ligne_".$i], $_POST["compte_ligne_".$i], str_replace(',', '.', $_POST["montant_ligne_".$i]), $_POST["sens_ligne_".$i], $libelle_ligne);
			if (!$id_ligne) $err = 1;
			$i++;
		}
		if ($err == 0) $db->commit();
		else $db->rollback();
		
		Header("Location: ecritures.php");
    }
    else
    {
		$db->rollback();
        dolibarr_print_error($db);
    }
}

// Controle saisie
function _controle_piece($db) {
    $date_piece = strftime( "%Y-%m-%d", mktime(0, 0, 0, substr($_POST["datep"],3,2), substr($_POST["datep"],0,2), substr($_POST["datep"],6)));
    $journal=$_POST["journal"];
    $libelle=$_POST["libelle"];
    $montant=$_POST["montant"];
    $tiers=$_POST["tiers"];
	$erreur = 0;
	if (!checkdate((int)substr($_POST["datep"],3,2), (int)substr($_POST["datep"],0,2), (int)substr($_POST["datep"],6)))
	{
		$erreurs[$erreur] = "Date invalide";
		$erreur++;
	}
	if ($journal == '0') 
	{
		$erreurs[$erreur] = "Journal non renseign";
		$erreur++;
	}
	if ($montant == 0)
	{
		$erreurs[$erreur] = "Montant non renseign";
		$erreur++;
	}
    $nb_lignes = $_POST["nb_lignes"];
	$i = 1;
	$total_debit = 0;
	$total_credit = 0;
	while ($i <= $nb_lignes) {
		if ($_POST["compte_ligne_".$i] == '0') {
			$erreurs[$erreur] = "Compte ligne ".$i." non renseign";
			$erreur++;
		}
		if (str_replace(',','.',$_POST["montant_ligne_".$i]) == 0) {
			$erreurs[$erreur] = "Montant ligne ".$i." non renseign";
			$erreur++;
		}
		else {
			if ($_POST["sens_ligne_".$i] == 'D') $total_debit += str_replace(',', '.', $_POST["montant_ligne_".$i]);
			else $total_credit += str_replace(',', '.', $_POST["montant_ligne_".$i]);
		}
		$i++;
	}
	$equilibre = $total_debit - $total_credit;
	if (round($equilibre, 2) != 0) {
		$erreurs[$erreur] = "Erreur d'quilibrage : le total des dbits est diffrent du total des crdits";
		$erreur++;
	}
	
	return $erreurs;
}

function _filtre_recherche($db) 
{
   global $langs, $bc, $limit, $total_pieces, $nb_pieces, $viewline, $user, $page, $limitsql, $sql_rech, $nb_lignes, $nb_erreurs;

  $sql = "SELECT count(*) as nb FROM ".MAIN_DB_PREFIX."compta_pieces as p";
  $sql .=" LEFT JOIN ".MAIN_DB_PREFIX."societe as s ON p.tiers = s.idp";
  $sql_rech="";
  $mode_search = 0;
  if ($_POST["req_journal"]) 
    { 
      if ($mode_search == 0) $sql_rech .= " WHERE";
	  else $sql_rech .= " AND";
	  $sql_rech .= " p.journal ='".$_POST["req_journal"]."'";
      $mode_search = 1;
    }
  if ($_POST["req_piece"]) 
    { 
      if ($mode_search == 0) $sql_rech .= " WHERE";
	  else $sql_rech .= " AND";
	  $sql_rech .= " p.num_piece ='".$_POST["req_piece"]."'";
      $mode_search = 1;
    }
  if ($_POST["req_journal"]) 
    { 
      if ($mode_search == 0) $sql_rech .= " WHERE";
	  else $sql_rech .= " AND";
	  $sql_rech .= " p.journal ='".$_POST["req_journal"]."'";
      $mode_search = 1;
    }
  if ($_POST["req_libelle"]) 
    { 
      if ($mode_search == 0) $sql_rech .= " WHERE";
	  else $sql_rech .= " AND";
	  $sql_rech .= " p.libelle like '%".strtolower($_POST["req_libelle"])."%'";
      $mode_search = 1;
    }
  if ($_POST["req_tiers"]) 
    { 
      if ($mode_search == 0) $sql_rech .= " WHERE";
	  else $sql_rech .= " AND";
	  $sql_rech .= " s.nom like '".strtolower($_POST["req_tiers"])."%'";
      $mode_search = 1;
    }
  if ($_POST["req_origine"]) 
    { 
      if ($mode_search == 0) $sql_rech .= " WHERE";
	  else $sql_rech .= " AND";
	  $sql_rech .= " p.code_origine like '".strtolower($_POST["req_origine"])."%'";
      $mode_search = 1;
    }
  if ($_POST["req_reference"]) 
    { 
      if ($mode_search == 0) $sql_rech .= " WHERE";
	  else $sql_rech .= " AND";
	  $sql_rech .= " p.reference like '".strtolower($_POST["req_reference"])."%'";
      $mode_search = 1;
    }
  if ($_POST["req_montant"]) 
    { 
      if ($mode_search == 0) $sql_rech .= " WHERE";
	  else $sql_rech .= " AND";
	  $sql_rech .= " p.montant = '".$_POST["req_montant"]."'";
      $mode_search = 1;
    }

  $sql .= $sql_rech;
  $result=$db->query($sql);
  if ($result)
    {
      $obj = $db->fetch_object($result);
      $nb_pieces = $obj->nb;
      $total_pieces = $nb_pieces;
	  $db->free($result);
    }
    else {
        dolibarr_print_error($db);
    }
		
  if ($nb_lignes == 0) $viewline = 22;
  else $viewline = 15 - ($nb_lignes + $nb_erreurs);
 
 if ($page > 0 && $mode_search == 0)
    {
      $limitsql = $nb_pieces - ($page * $viewline);
      if ($limitsql < $viewline)
		{
		  $limitsql = $viewline;
		}
      $nb_pieces = $limitsql;
    }
  else
    {
      $page = 0;
      $limitsql = $nb_pieces;
    }
}	

function _entete_pagination($db) 
{
   global $langs, $bc, $limit, $total_pieces, $nb_pieces, $viewline, $user, $page, $limitsql, $sql_rech, $nb_lignes, $nb_erreurs, $action_encours;

   $mesg='';
   $nbpage=floor($total_pieces/$viewline)+($total_pieces % $viewline > 0?1:0);  // Nombre de page total

   if ($limitsql > $viewline)
   {
        $mesg.='<a href="#"  onclick="document.getElementById(\'page\').value=\'';
		$mesg.=$page+1;
		$mesg.='\';';
		if ($action_encours == 'saisir_piece') $mesg .= 'document.form_saisie.submit();';
		else $mesg .= 'document.form_affich.submit();';
		$mesg.='">'.img_previous().'</a>';
   }
    $mesg.= ' Page '.($nbpage-$page).'/'.$nbpage.' ';
   if ($total_pieces > $limitsql )
   {
        $mesg.= '<a href="#"  onclick="document.getElementById(\'page\').value=\'';
		$mesg.= $page-1;
		$mesg.='\';';
		if ($action_encours == 'saisir_piece') $mesg .= 'document.form_saisie.submit();';
		else $mesg .= 'document.form_affich.submit();';
		$mesg.='">'.img_next().'</a>';
   }
	return $mesg;
}
?>
<script language="javascript">
// Affichage des lignes de la pice
function affichage_lignes(id_piece) {
	if (document.getElementById('Lignes_' + id_piece).style.display == 'inline') document.getElementById('Lignes_' + id_piece).style.display = 'none';
	else document.getElementById('Lignes_' + id_piece).style.display = 'inline';
	return false;

}
</script>